from __future__ import (absolute_import, division, print_function)

import numpy as np
import matplotlib.pyplot as plt
from mpl_toolkits.basemap import Basemap as Basemap

# cities colored by population rank.

m = Basemap()
shp_info = m.readshapefile('cities','cities')
x, y = zip(*m.cities)
pop = []
num_datapoints=0
for item in m.cities_info:
    population = item['POPULATION']
    num_datapoints += 1
    if population < 0: continue # population missing
    pop.append(population)
percentiles = np.linspace(0, 100, num_datapoints)  # Generate percentiles from 0 to 100
popranks = np.percentile(pop, percentiles)
colors = []
for rank in popranks:
    colors.append(plt.cm.jet(float(rank)/100.))
m.drawcoastlines()
m.fillcontinents()
m.scatter(x,y,25,colors,marker='o',edgecolors='none',zorder=10)
plt.title('City Locations colored by Population Rank')
plt.show()
